Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision )
@@ -2171,447 +886,132 @@
     }
 
     public $yyTraceFILE;
+
     public $yyTracePrompt;
+
     public $yyidx;                    /* Index of top element in stack */
     public $yyerrcnt;                 /* Shifts left before out of the error */
     public $yystack = array();  /* The parser's stack */
 
-    public $yyTokenName = array(
-        '$', 'VERT', 'COLON', 'RDEL',
-        'COMMENT', 'PHPSTARTTAG', 'PHPENDTAG', 'PHPENDSCRIPT',
-        'ASPSTARTTAG', 'ASPENDTAG', 'XMLTAG', 'TEXT',
-        'STRIPON', 'STRIPOFF', 'BLOCKSOURCE', 'LITERALSTART',
-        'LITERALEND', 'LITERAL', 'LDEL', 'DOLLAR',
-        'ID', 'EQUAL', 'PTR', 'LDELIF',
-        'LDELFOR', 'SEMICOLON', 'INCDEC', 'TO',
-        'STEP', 'LDELFOREACH', 'SPACE', 'AS',
-        'APTR', 'LDELSETFILTER', 'SMARTYBLOCKCHILDPARENT', 'LDELSLASH',
-        'ATTR', 'INTEGER', 'COMMA', 'OPENP',
-        'CLOSEP', 'MATH', 'UNIMATH', 'ANDSYM',
-        'ISIN', 'ISDIVBY', 'ISNOTDIVBY', 'ISEVEN',
-        'ISNOTEVEN', 'ISEVENBY', 'ISNOTEVENBY', 'ISODD',
-        'ISNOTODD', 'ISODDBY', 'ISNOTODDBY', 'INSTANCEOF',
-        'QMARK', 'NOT', 'TYPECAST', 'HEX',
-        'DOT', 'SINGLEQUOTESTRING', 'DOUBLECOLON', 'AT',
-        'HATCH', 'OPENB', 'CLOSEB', 'EQUALS',
-        'NOTEQUALS', 'GREATERTHAN', 'LESSTHAN', 'GREATEREQUAL',
-        'LESSEQUAL', 'IDENTITY', 'NONEIDENTITY', 'MOD',
-        'LAND', 'LOR', 'LXOR', 'QUOTE',
-        'BACKTICK', 'DOLLARID', 'error', 'start',
-        'template', 'template_element', 'smartytag', 'literal',
-        'literal_elements', 'literal_element', 'value', 'modifierlist',
-        'attributes', 'expr', 'varindexed', 'statement',
-        'statements', 'optspace', 'varvar', 'foraction',
-        'modparameters', 'attribute', 'ternary', 'array',
-        'ifcond', 'lop', 'variable', 'function',
-        'doublequoted_with_quotes', 'static_class_access', 'object', 'arrayindex',
-        'indexdef', 'varvarele', 'objectchain', 'objectelement',
-        'method', 'params', 'modifier', 'modparameter',
-        'arrayelements', 'arrayelement', 'doublequoted', 'doublequotedcontent',
-    );
+    public $yyTokenName = array('$', 'VERT', 'COLON', 'PHP', 'NOCACHE', 'TEXT', 'STRIPON', 'STRIPOFF', 'LITERALSTART',
+                                'LITERALEND', 'LITERAL', 'RDEL', 'SIMPELOUTPUT', 'LDEL', 'DOLLARID', 'EQUAL',
+                                'SIMPLETAG', 'ID', 'PTR', 'LDELIF', 'LDELFOR', 'SEMICOLON', 'INCDEC', 'TO', 'STEP',
+                                'LDELFOREACH', 'SPACE', 'AS', 'APTR', 'LDELSETFILTER', 'SMARTYBLOCKCHILDPARENT',
+                                'CLOSETAG', 'LDELSLASH', 'ATTR', 'INTEGER', 'COMMA', 'OPENP', 'CLOSEP', 'MATH',
+                                'UNIMATH', 'ISIN', 'INSTANCEOF', 'QMARK', 'NOT', 'TYPECAST', 'HEX', 'DOT',
+                                'SINGLEQUOTESTRING', 'DOUBLECOLON', 'NAMESPACE', 'AT', 'HATCH', 'OPENB', 'CLOSEB',
+                                'DOLLAR', 'LOGOP', 'TLOGOP', 'SINGLECOND', 'QUOTE', 'BACKTICK', 'error', 'start',
+                                'template', 'template_element', 'smartytag', 'literal', 'text_content',
+                                'literal_elements', 'literal_element', 'tag', 'variable', 'attributes', 'value', 'expr',
+                                'varindexed', 'modifierlist', 'statement', 'statements', 'foraction', 'varvar',
+                                'modparameters', 'attribute', 'ternary', 'array', 'lop', 'scond', 'ns1', 'function',
+                                'doublequoted_with_quotes', 'static_class_access', 'object', 'arrayindex', 'indexdef',
+                                'varvarele', 'objectchain', 'objectelement', 'method', 'params', 'modifier',
+                                'modparameter', 'arrayelements', 'arrayelement', 'doublequoted',
+                                'doublequotedcontent',);
 
-    public static $yyRuleName = array(
-        /*   0 */
-        "start ::= template",
-        /*   1 */
-        "template ::= template_element",
-        /*   2 */
-        "template ::= template template_element",
-        /*   3 */
-        "template ::=",
-        /*   4 */
-        "template_element ::= smartytag RDEL",
-        /*   5 */
-        "template_element ::= COMMENT",
-        /*   6 */
-        "template_element ::= literal",
-        /*   7 */
-        "template_element ::= PHPSTARTTAG",
-        /*   8 */
-        "template_element ::= PHPENDTAG",
-        /*   9 */
-        "template_element ::= PHPENDSCRIPT",
-        /*  10 */
-        "template_element ::= ASPSTARTTAG",
-        /*  11 */
-        "template_element ::= ASPENDTAG",
-        /*  12 */
-        "template_element ::= XMLTAG",
-        /*  13 */
-        "template_element ::= TEXT",
-        /*  14 */
-        "template_element ::= STRIPON",
-        /*  15 */
-        "template_element ::= STRIPOFF",
-        /*  16 */
-        "template_element ::= BLOCKSOURCE",
-        /*  17 */
-        "literal ::= LITERALSTART LITERALEND",
-        /*  18 */
-        "literal ::= LITERALSTART literal_elements LITERALEND",
-        /*  19 */
-        "literal_elements ::= literal_elements literal_element",
-        /*  20 */
-        "literal_elements ::=",
-        /*  21 */
-        "literal_element ::= literal",
-        /*  22 */
-        "literal_element ::= LITERAL",
-        /*  23 */
-        "smartytag ::= LDEL value",
-        /*  24 */
-        "smartytag ::= LDEL value modifierlist attributes",
-        /*  25 */
-        "smartytag ::= LDEL value attributes",
-        /*  26 */
-        "smartytag ::= LDEL expr modifierlist attributes",
-        /*  27 */
-        "smartytag ::= LDEL expr attributes",
-        /*  28 */
-        "smartytag ::= LDEL DOLLAR ID EQUAL value",
-        /*  29 */
-        "smartytag ::= LDEL DOLLAR ID EQUAL expr",
-        /*  30 */
-        "smartytag ::= LDEL DOLLAR ID EQUAL expr attributes",
-        /*  31 */
-        "smartytag ::= LDEL varindexed EQUAL expr attributes",
-        /*  32 */
-        "smartytag ::= LDEL ID attributes",
-        /*  33 */
-        "smartytag ::= LDEL ID",
-        /*  34 */
-        "smartytag ::= LDEL ID PTR ID attributes",
-        /*  35 */
-        "smartytag ::= LDEL ID modifierlist attributes",
-        /*  36 */
-        "smartytag ::= LDEL ID PTR ID modifierlist attributes",
-        /*  37 */
-        "smartytag ::= LDELIF expr",
-        /*  38 */
-        "smartytag ::= LDELIF expr attributes",
-        /*  39 */
-        "smartytag ::= LDELIF statement",
-        /*  40 */
-        "smartytag ::= LDELIF statement attributes",
-        /*  41 */
-        "smartytag ::= LDELFOR statements SEMICOLON optspace expr SEMICOLON optspace DOLLAR varvar foraction attributes",
-        /*  42 */
-        "foraction ::= EQUAL expr",
-        /*  43 */
-        "foraction ::= INCDEC",
-        /*  44 */
-        "smartytag ::= LDELFOR statement TO expr attributes",
-        /*  45 */
-        "smartytag ::= LDELFOR statement TO expr STEP expr attributes",
-        /*  46 */
-        "smartytag ::= LDELFOREACH attributes",
-        /*  47 */
-        "smartytag ::= LDELFOREACH SPACE value AS DOLLAR varvar attributes",
-        /*  48 */
-        "smartytag ::= LDELFOREACH SPACE value AS DOLLAR varvar APTR DOLLAR varvar attributes",
-        /*  49 */
-        "smartytag ::= LDELFOREACH SPACE expr AS DOLLAR varvar attributes",
-        /*  50 */
-        "smartytag ::= LDELFOREACH SPACE expr AS DOLLAR varvar APTR DOLLAR varvar attributes",
-        /*  51 */
-        "smartytag ::= LDELSETFILTER ID modparameters",
-        /*  52 */
-        "smartytag ::= LDELSETFILTER ID modparameters modifierlist",
-        /*  53 */
-        "smartytag ::= LDEL SMARTYBLOCKCHILDPARENT",
-        /*  54 */
-        "smartytag ::= LDELSLASH ID",
-        /*  55 */
-        "smartytag ::= LDELSLASH ID modifierlist",
-        /*  56 */
-        "smartytag ::= LDELSLASH ID PTR ID",
-        /*  57 */
-        "smartytag ::= LDELSLASH ID PTR ID modifierlist",
-        /*  58 */
-        "attributes ::= attributes attribute",
-        /*  59 */
-        "attributes ::= attribute",
-        /*  60 */
-        "attributes ::=",
-        /*  61 */
-        "attribute ::= SPACE ID EQUAL ID",
-        /*  62 */
-        "attribute ::= ATTR expr",
-        /*  63 */
-        "attribute ::= ATTR value",
-        /*  64 */
-        "attribute ::= SPACE ID",
-        /*  65 */
-        "attribute ::= SPACE expr",
-        /*  66 */
-        "attribute ::= SPACE value",
-        /*  67 */
-        "attribute ::= SPACE INTEGER EQUAL expr",
-        /*  68 */
-        "statements ::= statement",
-        /*  69 */
-        "statements ::= statements COMMA statement",
-        /*  70 */
-        "statement ::= DOLLAR varvar EQUAL expr",
-        /*  71 */
-        "statement ::= varindexed EQUAL expr",
-        /*  72 */
-        "statement ::= OPENP statement CLOSEP",
-        /*  73 */
-        "expr ::= value",
-        /*  74 */
-        "expr ::= ternary",
-        /*  75 */
-        "expr ::= DOLLAR ID COLON ID",
-        /*  76 */
-        "expr ::= expr MATH value",
-        /*  77 */
-        "expr ::= expr UNIMATH value",
-        /*  78 */
-        "expr ::= expr ANDSYM value",
-        /*  79 */
-        "expr ::= array",
-        /*  80 */
-        "expr ::= expr modifierlist",
-        /*  81 */
-        "expr ::= expr ifcond expr",
-        /*  82 */
-        "expr ::= expr ISIN array",
-        /*  83 */
-        "expr ::= expr ISIN value",
-        /*  84 */
-        "expr ::= expr lop expr",
-        /*  85 */
-        "expr ::= expr ISDIVBY expr",
-        /*  86 */
-        "expr ::= expr ISNOTDIVBY expr",
-        /*  87 */
-        "expr ::= expr ISEVEN",
-        /*  88 */
-        "expr ::= expr ISNOTEVEN",
-        /*  89 */
-        "expr ::= expr ISEVENBY expr",
-        /*  90 */
-        "expr ::= expr ISNOTEVENBY expr",
-        /*  91 */
-        "expr ::= expr ISODD",
-        /*  92 */
-        "expr ::= expr ISNOTODD",
-        /*  93 */
-        "expr ::= expr ISODDBY expr",
-        /*  94 */
-        "expr ::= expr ISNOTODDBY expr",
-        /*  95 */
-        "expr ::= value INSTANCEOF ID",
-        /*  96 */
-        "expr ::= value INSTANCEOF value",
-        /*  97 */
-        "ternary ::= OPENP expr CLOSEP QMARK DOLLAR ID COLON expr",
-        /*  98 */
-        "ternary ::= OPENP expr CLOSEP QMARK expr COLON expr",
-        /*  99 */
-        "value ::= variable",
-        /* 100 */
-        "value ::= UNIMATH value",
-        /* 101 */
-        "value ::= NOT value",
-        /* 102 */
-        "value ::= TYPECAST value",
-        /* 103 */
-        "value ::= variable INCDEC",
-        /* 104 */
-        "value ::= HEX",
-        /* 105 */
-        "value ::= INTEGER",
-        /* 106 */
-        "value ::= INTEGER DOT INTEGER",
-        /* 107 */
-        "value ::= INTEGER DOT",
-        /* 108 */
-        "value ::= DOT INTEGER",
-        /* 109 */
-        "value ::= ID",
-        /* 110 */
-        "value ::= function",
-        /* 111 */
-        "value ::= OPENP expr CLOSEP",
-        /* 112 */
-        "value ::= SINGLEQUOTESTRING",
-        /* 113 */
-        "value ::= doublequoted_with_quotes",
-        /* 114 */
-        "value ::= ID DOUBLECOLON static_class_access",
-        /* 115 */
-        "value ::= varindexed DOUBLECOLON static_class_access",
-        /* 116 */
-        "value ::= smartytag RDEL",
-        /* 117 */
-        "value ::= value modifierlist",
-        /* 118 */
-        "variable ::= varindexed",
-        /* 119 */
-        "variable ::= DOLLAR varvar AT ID",
-        /* 120 */
-        "variable ::= object",
-        /* 121 */
-        "variable ::= HATCH ID HATCH",
-        /* 122 */
-        "variable ::= HATCH ID HATCH arrayindex",
-        /* 123 */
-        "variable ::= HATCH variable HATCH",
-        /* 124 */
-        "variable ::= HATCH variable HATCH arrayindex",
-        /* 125 */
-        "varindexed ::= DOLLAR varvar arrayindex",
-        /* 126 */
-        "arrayindex ::= arrayindex indexdef",
-        /* 127 */
-        "arrayindex ::=",
-        /* 128 */
-        "indexdef ::= DOT DOLLAR varvar",
-        /* 129 */
-        "indexdef ::= DOT DOLLAR varvar AT ID",
-        /* 130 */
-        "indexdef ::= DOT ID",
-        /* 131 */
-        "indexdef ::= DOT INTEGER",
-        /* 132 */
-        "indexdef ::= DOT LDEL expr RDEL",
-        /* 133 */
-        "indexdef ::= OPENB ID CLOSEB",
-        /* 134 */
-        "indexdef ::= OPENB ID DOT ID CLOSEB",
-        /* 135 */
-        "indexdef ::= OPENB expr CLOSEB",
-        /* 136 */
-        "indexdef ::= OPENB CLOSEB",
-        /* 137 */
-        "varvar ::= varvarele",
-        /* 138 */
-        "varvar ::= varvar varvarele",
-        /* 139 */
-        "varvarele ::= ID",
-        /* 140 */
-        "varvarele ::= LDEL expr RDEL",
-        /* 141 */
-        "object ::= varindexed objectchain",
-        /* 142 */
-        "objectchain ::= objectelement",
-        /* 143 */
-        "objectchain ::= objectchain objectelement",
-        /* 144 */
-        "objectelement ::= PTR ID arrayindex",
-        /* 145 */
-        "objectelement ::= PTR DOLLAR varvar arrayindex",
-        /* 146 */
-        "objectelement ::= PTR LDEL expr RDEL arrayindex",
-        /* 147 */
-        "objectelement ::= PTR ID LDEL expr RDEL arrayindex",
-        /* 148 */
-        "objectelement ::= PTR method",
-        /* 149 */
-        "function ::= ID OPENP params CLOSEP",
-        /* 150 */
-        "method ::= ID OPENP params CLOSEP",
-        /* 151 */
-        "method ::= DOLLAR ID OPENP params CLOSEP",
-        /* 152 */
-        "params ::= params COMMA expr",
-        /* 153 */
-        "params ::= expr",
-        /* 154 */
-        "params ::=",
-        /* 155 */
-        "modifierlist ::= modifierlist modifier modparameters",
-        /* 156 */
-        "modifierlist ::= modifier modparameters",
-        /* 157 */
-        "modifier ::= VERT AT ID",
-        /* 158 */
-        "modifier ::= VERT ID",
-        /* 159 */
-        "modparameters ::= modparameters modparameter",
-        /* 160 */
-        "modparameters ::=",
-        /* 161 */
-        "modparameter ::= COLON value",
-        /* 162 */
-        "modparameter ::= COLON array",
-        /* 163 */
-        "static_class_access ::= method",
-        /* 164 */
-        "static_class_access ::= method objectchain",
-        /* 165 */
-        "static_class_access ::= ID",
-        /* 166 */
-        "static_class_access ::= DOLLAR ID arrayindex",
-        /* 167 */
-        "static_class_access ::= DOLLAR ID arrayindex objectchain",
-        /* 168 */
-        "ifcond ::= EQUALS",
-        /* 169 */
-        "ifcond ::= NOTEQUALS",
-        /* 170 */
-        "ifcond ::= GREATERTHAN",
-        /* 171 */
-        "ifcond ::= LESSTHAN",
-        /* 172 */
-        "ifcond ::= GREATEREQUAL",
-        /* 173 */
-        "ifcond ::= LESSEQUAL",
-        /* 174 */
-        "ifcond ::= IDENTITY",
-        /* 175 */
-        "ifcond ::= NONEIDENTITY",
-        /* 176 */
-        "ifcond ::= MOD",
-        /* 177 */
-        "lop ::= LAND",
-        /* 178 */
-        "lop ::= LOR",
-        /* 179 */
-        "lop ::= LXOR",
-        /* 180 */
-        "array ::= OPENB arrayelements CLOSEB",
-        /* 181 */
-        "arrayelements ::= arrayelement",
-        /* 182 */
-        "arrayelements ::= arrayelements COMMA arrayelement",
-        /* 183 */
-        "arrayelements ::=",
-        /* 184 */
-        "arrayelement ::= value APTR expr",
-        /* 185 */
-        "arrayelement ::= ID APTR expr",
-        /* 186 */
-        "arrayelement ::= expr",
-        /* 187 */
-        "doublequoted_with_quotes ::= QUOTE QUOTE",
-        /* 188 */
-        "doublequoted_with_quotes ::= QUOTE doublequoted QUOTE",
-        /* 189 */
-        "doublequoted ::= doublequoted doublequotedcontent",
-        /* 190 */
-        "doublequoted ::= doublequotedcontent",
-        /* 191 */
-        "doublequotedcontent ::= BACKTICK variable BACKTICK",
-        /* 192 */
-        "doublequotedcontent ::= BACKTICK expr BACKTICK",
-        /* 193 */
-        "doublequotedcontent ::= DOLLARID",
-        /* 194 */
-        "doublequotedcontent ::= LDEL variable RDEL",
-        /* 195 */
-        "doublequotedcontent ::= LDEL expr RDEL",
-        /* 196 */
-        "doublequotedcontent ::= smartytag RDEL",
-        /* 197 */
-        "doublequotedcontent ::= TEXT",
-        /* 198 */
-        "optspace ::= SPACE",
-        /* 199 */
-        "optspace ::=",
-    );
+    public static $yyRuleName = array('start ::= template', 'template ::= template_element',
+                                      'template ::= template template_element', 'template ::=',
+                                      'template_element ::= smartytag', 'template_element ::= literal',
+                                      'template_element ::= PHP', 'template_element ::= NOCACHE',
+                                      'template_element ::= text_content', 'text_content ::= TEXT',
+                                      'text_content ::= text_content TEXT', 'template_element ::= STRIPON',
+                                      'template_element ::= STRIPOFF', 'literal ::= LITERALSTART LITERALEND',
+                                      'literal ::= LITERALSTART literal_elements LITERALEND',
+                                      'literal_elements ::= literal_elements literal_element', 'literal_elements ::=',
+                                      'literal_element ::= literal', 'literal_element ::= LITERAL',
+                                      'smartytag ::= tag RDEL', 'smartytag ::= SIMPELOUTPUT', 'tag ::= LDEL variable',
+                                      'tag ::= LDEL variable attributes', 'tag ::= LDEL value',
+                                      'tag ::= LDEL value attributes', 'tag ::= LDEL expr',
+                                      'tag ::= LDEL expr attributes', 'tag ::= LDEL DOLLARID EQUAL value',
+                                      'tag ::= LDEL DOLLARID EQUAL expr', 'tag ::= LDEL DOLLARID EQUAL expr attributes',
+                                      'tag ::= LDEL varindexed EQUAL expr attributes', 'smartytag ::= SIMPLETAG',
+                                      'tag ::= LDEL ID attributes', 'tag ::= LDEL ID',
+                                      'tag ::= LDEL ID modifierlist attributes', 'tag ::= LDEL ID PTR ID attributes',
+                                      'tag ::= LDEL ID PTR ID modifierlist attributes', 'tag ::= LDELIF expr',
+                                      'tag ::= LDELIF expr attributes', 'tag ::= LDELIF statement',
+                                      'tag ::= LDELIF statement attributes',
+                                      'tag ::= LDELFOR statements SEMICOLON expr SEMICOLON varindexed foraction attributes',
+                                      'foraction ::= EQUAL expr', 'foraction ::= INCDEC',
+                                      'tag ::= LDELFOR statement TO expr attributes',
+                                      'tag ::= LDELFOR statement TO expr STEP expr attributes',
+                                      'tag ::= LDELFOREACH attributes',
+                                      'tag ::= LDELFOREACH SPACE value AS varvar attributes',
+                                      'tag ::= LDELFOREACH SPACE value AS varvar APTR varvar attributes',
+                                      'tag ::= LDELFOREACH SPACE expr AS varvar attributes',
+                                      'tag ::= LDELFOREACH SPACE expr AS varvar APTR varvar attributes',
+                                      'tag ::= LDELSETFILTER ID modparameters',
+                                      'tag ::= LDELSETFILTER ID modparameters modifierlist',
+                                      'tag ::= LDEL SMARTYBLOCKCHILDPARENT', 'smartytag ::= CLOSETAG',
+                                      'tag ::= LDELSLASH ID', 'tag ::= LDELSLASH ID modifierlist',
+                                      'tag ::= LDELSLASH ID PTR ID', 'tag ::= LDELSLASH ID PTR ID modifierlist',
+                                      'attributes ::= attributes attribute', 'attributes ::= attribute',
+                                      'attributes ::=', 'attribute ::= SPACE ID EQUAL ID', 'attribute ::= ATTR expr',
+                                      'attribute ::= ATTR value', 'attribute ::= SPACE ID', 'attribute ::= SPACE expr',
+                                      'attribute ::= SPACE value', 'attribute ::= SPACE INTEGER EQUAL expr',
+                                      'statements ::= statement', 'statements ::= statements COMMA statement',
+                                      'statement ::= DOLLARID EQUAL INTEGER', 'statement ::= DOLLARID EQUAL expr',
+                                      'statement ::= varindexed EQUAL expr', 'statement ::= OPENP statement CLOSEP',
+                                      'expr ::= value', 'expr ::= ternary', 'expr ::= DOLLARID COLON ID',
+                                      'expr ::= expr MATH value', 'expr ::= expr UNIMATH value', 'expr ::= array',
+                                      'expr ::= expr modifierlist', 'expr ::= expr lop expr', 'expr ::= expr scond',
+                                      'expr ::= expr ISIN array', 'expr ::= expr ISIN value',
+                                      'expr ::= variable INSTANCEOF ns1', 'expr ::= variable INSTANCEOF variable',
+                                      'ternary ::= OPENP expr CLOSEP QMARK DOLLARID COLON expr',
+                                      'ternary ::= OPENP expr CLOSEP QMARK expr COLON expr', 'value ::= variable',
+                                      'value ::= UNIMATH value', 'value ::= NOT value', 'value ::= TYPECAST value',
+                                      'value ::= variable INCDEC', 'value ::= HEX', 'value ::= INTEGER',
+                                      'value ::= INTEGER DOT INTEGER', 'value ::= INTEGER DOT', 'value ::= DOT INTEGER',
+                                      'value ::= ID', 'value ::= function', 'value ::= OPENP expr CLOSEP',
+                                      'value ::= SINGLEQUOTESTRING', 'value ::= doublequoted_with_quotes',
+                                      'value ::= varindexed DOUBLECOLON static_class_access', 'value ::= smartytag',
+                                      'value ::= value modifierlist', 'value ::= NAMESPACE',
+                                      'value ::= ns1 DOUBLECOLON static_class_access', 'ns1 ::= ID',
+                                      'ns1 ::= NAMESPACE', 'variable ::= DOLLARID', 'variable ::= varindexed',
+                                      'variable ::= varvar AT ID', 'variable ::= object', 'variable ::= HATCH ID HATCH',
+                                      'variable ::= HATCH ID HATCH arrayindex', 'variable ::= HATCH variable HATCH',
+                                      'variable ::= HATCH variable HATCH arrayindex',
+                                      'varindexed ::= DOLLARID arrayindex', 'varindexed ::= varvar arrayindex',
+                                      'arrayindex ::= arrayindex indexdef', 'arrayindex ::=',
+                                      'indexdef ::= DOT DOLLARID', 'indexdef ::= DOT varvar',
+                                      'indexdef ::= DOT varvar AT ID', 'indexdef ::= DOT ID',
+                                      'indexdef ::= DOT INTEGER', 'indexdef ::= DOT LDEL expr RDEL',
+                                      'indexdef ::= OPENB ID CLOSEB', 'indexdef ::= OPENB ID DOT ID CLOSEB',
+                                      'indexdef ::= OPENB SINGLEQUOTESTRING CLOSEB',
+                                      'indexdef ::= OPENB INTEGER CLOSEB', 'indexdef ::= OPENB DOLLARID CLOSEB',
+                                      'indexdef ::= OPENB variable CLOSEB', 'indexdef ::= OPENB value CLOSEB',
+                                      'indexdef ::= OPENB expr CLOSEB', 'indexdef ::= OPENB CLOSEB',
+                                      'varvar ::= DOLLARID', 'varvar ::= DOLLAR', 'varvar ::= varvar varvarele',
+                                      'varvarele ::= ID', 'varvarele ::= SIMPELOUTPUT', 'varvarele ::= LDEL expr RDEL',
+                                      'object ::= varindexed objectchain', 'objectchain ::= objectelement',
+                                      'objectchain ::= objectchain objectelement',
+                                      'objectelement ::= PTR ID arrayindex', 'objectelement ::= PTR varvar arrayindex',
+                                      'objectelement ::= PTR LDEL expr RDEL arrayindex',
+                                      'objectelement ::= PTR ID LDEL expr RDEL arrayindex',
+                                      'objectelement ::= PTR method', 'function ::= ns1 OPENP params CLOSEP',
+                                      'method ::= ID OPENP params CLOSEP', 'method ::= DOLLARID OPENP params CLOSEP',
+                                      'params ::= params COMMA expr', 'params ::= expr', 'params ::=',
+                                      'modifierlist ::= modifierlist modifier modparameters',
+                                      'modifierlist ::= modifier modparameters', 'modifier ::= VERT AT ID',
+                                      'modifier ::= VERT ID', 'modparameters ::= modparameters modparameter',
+                                      'modparameters ::=', 'modparameter ::= COLON value',
+                                      'modparameter ::= COLON array', 'static_class_access ::= method',
+                                      'static_class_access ::= method objectchain', 'static_class_access ::= ID',
+                                      'static_class_access ::= DOLLARID arrayindex',
+                                      'static_class_access ::= DOLLARID arrayindex objectchain', 'lop ::= LOGOP',
+                                      'lop ::= TLOGOP', 'scond ::= SINGLECOND', 'array ::= OPENB arrayelements CLOSEB',
+                                      'arrayelements ::= arrayelement',
+                                      'arrayelements ::= arrayelements COMMA arrayelement', 'arrayelements ::=',
+                                      'arrayelement ::= value APTR expr', 'arrayelement ::= ID APTR expr',
+                                      'arrayelement ::= expr', 'doublequoted_with_quotes ::= QUOTE QUOTE',
+                                      'doublequoted_with_quotes ::= QUOTE doublequoted QUOTE',
+                                      'doublequoted ::= doublequoted doublequotedcontent',
+                                      'doublequoted ::= doublequotedcontent',
+                                      'doublequotedcontent ::= BACKTICK variable BACKTICK',
+                                      'doublequotedcontent ::= BACKTICK expr BACKTICK',
+                                      'doublequotedcontent ::= DOLLARID', 'doublequotedcontent ::= LDEL variable RDEL',
+                                      'doublequotedcontent ::= LDEL expr RDEL', 'doublequotedcontent ::= smartytag',
+                                      'doublequotedcontent ::= TEXT',);
 
     public function tokenName($tokenType)
     {
@@ -2619,7 +1019,7 @@
             return 'End of Input';
         }
         if ($tokenType > 0 && $tokenType < count($this->yyTokenName)) {
-            return $this->yyTokenName[$tokenType];
+            return $this->yyTokenName[ $tokenType ];
         } else {
             return "Unknown";
         }
@@ -2635,14 +1035,12 @@
 
     public function yy_pop_parser_stack()
     {
-        if (!count($this->yystack)) {
+        if (empty($this->yystack)) {
             return;
         }
         $yytos = array_pop($this->yystack);
         if ($this->yyTraceFILE && $this->yyidx >= 0) {
-            fwrite($this->yyTraceFILE,
-                   $this->yyTracePrompt . 'Popping ' . $this->yyTokenName[$yytos->major] .
-                   "\n");
+            fwrite($this->yyTraceFILE, $this->yyTracePrompt . 'Popping ' . $this->yyTokenName[ $yytos->major ] . "\n");
         }
         $yymajor = $yytos->major;
         self::yy_destructor($yymajor, $yytos->minor);
@@ -2663,11 +1061,19 @@
 
     public function yy_get_expected_tokens($token)
     {
+        static $res3 = array();
+        static $res4 = array();
-        $state = $this->yystack[$this->yyidx]->stateno;
+        $state = $this->yystack[ $this->yyidx ]->stateno;
-        $expected = self::$yyExpectedTokens[$state];
+        $expected = self::$yyExpectedTokens[ $state ];
-        if (in_array($token, self::$yyExpectedTokens[$state], true)) {
+        if (isset($res3[ $state ][ $token ])) {
+            if ($res3[ $state ][ $token ]) {
-            return $expected;
-        }
+                return $expected;
+            }
+        } else {
+            if ($res3[ $state ][ $token ] = in_array($token, self::$yyExpectedTokens[ $state ], true)) {
+                return $expected;
+            }
+        }
         $stack = $this->yystack;
         $yyidx = $this->yyidx;
         do {
